"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class IlluminaSummaryV2(ProtocolElement):
    """
    This is the summary provided by Illumina V2 germline samples
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "CNV",
        "CNV_IN_GENES",
        "CNV_PERCENT_IN_GENES",
        "DELETIONS",
        "DELETIONS_ALL",
        "DELETIONS_IN_CODING_REGIONS",
        "DELETIONS_IN_EXONS",
        "DELETIONS_IN_GENES",
        "DELETIONS_IN_MATURE_MIRNA",
        "DELETIONS_IN_SPLICE_SITE_REGIONS",
        "DELETIONS_IN_UTR_REGIONS",
        "DELETIONS_PERCENT_FOUND_IN_DBSNP",
        "DELETION_HET_HOM_RATIO",
        "DIVERSITY",
        "FRAGMENT_LENGTH_MAX",
        "FRAGMENT_LENGTH_MEDIAN",
        "FRAGMENT_LENGTH_MIN",
        "FRAGMENT_LENGTH_SD",
        "FRAMESHIFT_DELETIONS",
        "FRAMESHIFT_INSERTIONS",
        "INDELS",
        "INDELS_ALL",
        "INDELS_PERCENT_FOUND_IN_DBSNP",
        "INDEL_HET_HOM_RATIO",
        "INSERTIONS",
        "INSERTIONS_ALL",
        "INSERTIONS_IN_CODING_REGIONS",
        "INSERTIONS_IN_EXONS",
        "INSERTIONS_IN_GENES",
        "INSERTIONS_IN_MATURE_MIRNA",
        "INSERTIONS_IN_SPLICE_SITE_REGIONS",
        "INSERTIONS_IN_UTR_REGIONS",
        "INSERTIONS_PERCENT_FOUND_IN_DBSNP",
        "INSERTION_HET_HOM_RATIO",
        "MEAN_COVERAGE",
        "MISMATCH_RATE_READ_1",
        "MISMATCH_RATE_READ_2",
        "NON_SYNONYMOUS_DELETIONS",
        "NON_SYNONYMOUS_INSERTIONS",
        "NON_SYNONYMOUS_SNVS",
        "PAIRED_END",
        "PERCENT_ALIGNED_BASES_READ_1",
        "PERCENT_ALIGNED_BASES_READ_2",
        "PERCENT_ALIGNED_READ_1",
        "PERCENT_ALIGNED_READ_2",
        "PERCENT_DUPLICATE_PAIRED_READS",
        "PERCENT_Q30_BASES",
        "PERCENT_Q30_BASES_READ_1",
        "PERCENT_Q30_BASES_READ_2",
        "REFERENCE_GENOME",
        "RUNFOLDER",
        "SAMPLE_ID",
        "SAMPLE_NAME",
        "SNVS",
        "SNVS_ALL",
        "SNVS_IN_CODING_REGIONS",
        "SNVS_IN_EXONS",
        "SNVS_IN_GENES",
        "SNVS_IN_MATURE_MIRNA",
        "SNVS_IN_SPLICE_SITE_REGIONS",
        "SNVS_IN_UTR_REGIONS",
        "SNVS_PERCENT_FOUND_IN_DBSNP",
        "SNV_HET_HOM_RATIO",
        "SNV_TS_TV_RATIO",
        "STOP_GAINED_DELETIONS",
        "STOP_GAINED_INSERTIONS",
        "STOP_GAINED_SNVS",
        "STOP_LOST_DELETIONS",
        "STOP_LOST_INSERTIONS",
        "STOP_LOST_SNVS",
        "SV_DELETIONS",
        "SV_DELETIONS_IN_GENES",
        "SV_INSERTIONS",
        "SV_INSERTIONS_IN_GENES",
        "SV_INVERSIONS",
        "SV_INVERSIONS_IN_GENES",
        "SV_PERCENT_DELETIONS_IN_GENES",
        "SV_PERCENT_INSERTIONS_IN_GENES",
        "SV_PERCENT_INVERSIONS_IN_GENES",
        "SV_PERCENT_TANDEM_DUPLICATIONS_IN_GENES",
        "SV_TANDEM_DUPLICATIONS",
        "SV_TANDEM_DUPLICATIONS_IN_GENES",
        "SYNONYMOUS_SNVS",
        "TOTAL_ALIGNED_BASES_READ_1",
        "TOTAL_ALIGNED_BASES_READ_2",
        "TOTAL_ALIGNED_READ_1",
        "TOTAL_ALIGNED_READ_2",
        "TOTAL_PF_BASES",
        "TOTAL_PF_BASES_READ_1",
        "TOTAL_PF_BASES_READ_2",
        "TOTAL_PF_READS",
        "illumina_version",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_1 import metrics as metrics_1_2_3

        return {
            "illumina_version": metrics_1_2_3.IlluminaVersion,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_1 import metrics as metrics_1_2_3

        return {
            "org.gel.models.report.avro.IlluminaVersion": metrics_1_2_3.IlluminaVersion,
            "org.gel.models.report.avro.IlluminaSummaryV2": metrics_1_2_3.IlluminaSummaryV2,
        }

    __slots__ = [
        "CNV",
        "CNV_IN_GENES",
        "CNV_PERCENT_IN_GENES",
        "DELETIONS",
        "DELETIONS_ALL",
        "DELETIONS_IN_CODING_REGIONS",
        "DELETIONS_IN_EXONS",
        "DELETIONS_IN_GENES",
        "DELETIONS_IN_MATURE_MIRNA",
        "DELETIONS_IN_SPLICE_SITE_REGIONS",
        "DELETIONS_IN_UTR_REGIONS",
        "DELETIONS_PERCENT_FOUND_IN_DBSNP",
        "DELETION_HET_HOM_RATIO",
        "DIVERSITY",
        "FRAGMENT_LENGTH_MAX",
        "FRAGMENT_LENGTH_MEDIAN",
        "FRAGMENT_LENGTH_MIN",
        "FRAGMENT_LENGTH_SD",
        "FRAMESHIFT_DELETIONS",
        "FRAMESHIFT_INSERTIONS",
        "INDELS",
        "INDELS_ALL",
        "INDELS_PERCENT_FOUND_IN_DBSNP",
        "INDEL_HET_HOM_RATIO",
        "INSERTIONS",
        "INSERTIONS_ALL",
        "INSERTIONS_IN_CODING_REGIONS",
        "INSERTIONS_IN_EXONS",
        "INSERTIONS_IN_GENES",
        "INSERTIONS_IN_MATURE_MIRNA",
        "INSERTIONS_IN_SPLICE_SITE_REGIONS",
        "INSERTIONS_IN_UTR_REGIONS",
        "INSERTIONS_PERCENT_FOUND_IN_DBSNP",
        "INSERTION_HET_HOM_RATIO",
        "MEAN_COVERAGE",
        "MISMATCH_RATE_READ_1",
        "MISMATCH_RATE_READ_2",
        "NON_SYNONYMOUS_DELETIONS",
        "NON_SYNONYMOUS_INSERTIONS",
        "NON_SYNONYMOUS_SNVS",
        "PAIRED_END",
        "PERCENT_ALIGNED_BASES_READ_1",
        "PERCENT_ALIGNED_BASES_READ_2",
        "PERCENT_ALIGNED_READ_1",
        "PERCENT_ALIGNED_READ_2",
        "PERCENT_DUPLICATE_PAIRED_READS",
        "PERCENT_Q30_BASES",
        "PERCENT_Q30_BASES_READ_1",
        "PERCENT_Q30_BASES_READ_2",
        "REFERENCE_GENOME",
        "RUNFOLDER",
        "SAMPLE_ID",
        "SAMPLE_NAME",
        "SNVS",
        "SNVS_ALL",
        "SNVS_IN_CODING_REGIONS",
        "SNVS_IN_EXONS",
        "SNVS_IN_GENES",
        "SNVS_IN_MATURE_MIRNA",
        "SNVS_IN_SPLICE_SITE_REGIONS",
        "SNVS_IN_UTR_REGIONS",
        "SNVS_PERCENT_FOUND_IN_DBSNP",
        "SNV_HET_HOM_RATIO",
        "SNV_TS_TV_RATIO",
        "STOP_GAINED_DELETIONS",
        "STOP_GAINED_INSERTIONS",
        "STOP_GAINED_SNVS",
        "STOP_LOST_DELETIONS",
        "STOP_LOST_INSERTIONS",
        "STOP_LOST_SNVS",
        "SV_DELETIONS",
        "SV_DELETIONS_IN_GENES",
        "SV_INSERTIONS",
        "SV_INSERTIONS_IN_GENES",
        "SV_INVERSIONS",
        "SV_INVERSIONS_IN_GENES",
        "SV_PERCENT_DELETIONS_IN_GENES",
        "SV_PERCENT_INSERTIONS_IN_GENES",
        "SV_PERCENT_INVERSIONS_IN_GENES",
        "SV_PERCENT_TANDEM_DUPLICATIONS_IN_GENES",
        "SV_TANDEM_DUPLICATIONS",
        "SV_TANDEM_DUPLICATIONS_IN_GENES",
        "SYNONYMOUS_SNVS",
        "TOTAL_ALIGNED_BASES_READ_1",
        "TOTAL_ALIGNED_BASES_READ_2",
        "TOTAL_ALIGNED_READ_1",
        "TOTAL_ALIGNED_READ_2",
        "TOTAL_PF_BASES",
        "TOTAL_PF_BASES_READ_1",
        "TOTAL_PF_BASES_READ_2",
        "TOTAL_PF_READS",
        "illumina_version",
    ]

    def __init__(
        self,
        CNV,
        CNV_IN_GENES,
        CNV_PERCENT_IN_GENES,
        DELETIONS,
        DELETIONS_ALL,
        DELETIONS_IN_CODING_REGIONS,
        DELETIONS_IN_EXONS,
        DELETIONS_IN_GENES,
        DELETIONS_IN_MATURE_MIRNA,
        DELETIONS_IN_SPLICE_SITE_REGIONS,
        DELETIONS_IN_UTR_REGIONS,
        DELETIONS_PERCENT_FOUND_IN_DBSNP,
        DELETION_HET_HOM_RATIO,
        DIVERSITY,
        FRAGMENT_LENGTH_MAX,
        FRAGMENT_LENGTH_MEDIAN,
        FRAGMENT_LENGTH_MIN,
        FRAGMENT_LENGTH_SD,
        FRAMESHIFT_DELETIONS,
        FRAMESHIFT_INSERTIONS,
        INDELS,
        INDELS_ALL,
        INDELS_PERCENT_FOUND_IN_DBSNP,
        INDEL_HET_HOM_RATIO,
        INSERTIONS,
        INSERTIONS_ALL,
        INSERTIONS_IN_CODING_REGIONS,
        INSERTIONS_IN_EXONS,
        INSERTIONS_IN_GENES,
        INSERTIONS_IN_MATURE_MIRNA,
        INSERTIONS_IN_SPLICE_SITE_REGIONS,
        INSERTIONS_IN_UTR_REGIONS,
        INSERTIONS_PERCENT_FOUND_IN_DBSNP,
        INSERTION_HET_HOM_RATIO,
        MEAN_COVERAGE,
        MISMATCH_RATE_READ_1,
        MISMATCH_RATE_READ_2,
        NON_SYNONYMOUS_DELETIONS,
        NON_SYNONYMOUS_INSERTIONS,
        NON_SYNONYMOUS_SNVS,
        PAIRED_END,
        PERCENT_ALIGNED_BASES_READ_1,
        PERCENT_ALIGNED_BASES_READ_2,
        PERCENT_ALIGNED_READ_1,
        PERCENT_ALIGNED_READ_2,
        PERCENT_DUPLICATE_PAIRED_READS,
        PERCENT_Q30_BASES,
        PERCENT_Q30_BASES_READ_1,
        PERCENT_Q30_BASES_READ_2,
        REFERENCE_GENOME,
        RUNFOLDER,
        SAMPLE_ID,
        SAMPLE_NAME,
        SNVS,
        SNVS_ALL,
        SNVS_IN_CODING_REGIONS,
        SNVS_IN_EXONS,
        SNVS_IN_GENES,
        SNVS_IN_MATURE_MIRNA,
        SNVS_IN_SPLICE_SITE_REGIONS,
        SNVS_IN_UTR_REGIONS,
        SNVS_PERCENT_FOUND_IN_DBSNP,
        SNV_HET_HOM_RATIO,
        SNV_TS_TV_RATIO,
        STOP_GAINED_DELETIONS,
        STOP_GAINED_INSERTIONS,
        STOP_GAINED_SNVS,
        STOP_LOST_DELETIONS,
        STOP_LOST_INSERTIONS,
        STOP_LOST_SNVS,
        SV_DELETIONS,
        SV_DELETIONS_IN_GENES,
        SV_INSERTIONS,
        SV_INSERTIONS_IN_GENES,
        SV_INVERSIONS,
        SV_INVERSIONS_IN_GENES,
        SV_PERCENT_DELETIONS_IN_GENES,
        SV_PERCENT_INSERTIONS_IN_GENES,
        SV_PERCENT_INVERSIONS_IN_GENES,
        SV_PERCENT_TANDEM_DUPLICATIONS_IN_GENES,
        SV_TANDEM_DUPLICATIONS,
        SV_TANDEM_DUPLICATIONS_IN_GENES,
        SYNONYMOUS_SNVS,
        TOTAL_ALIGNED_BASES_READ_1,
        TOTAL_ALIGNED_BASES_READ_2,
        TOTAL_ALIGNED_READ_1,
        TOTAL_ALIGNED_READ_2,
        TOTAL_PF_BASES,
        TOTAL_PF_BASES_READ_1,
        TOTAL_PF_BASES_READ_2,
        TOTAL_PF_READS,
        illumina_version,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_3.IlluminaSummaryV2 model.

        :param CNV:
        :type CNV: int
        :param CNV_IN_GENES:
        :type CNV_IN_GENES: int
        :param CNV_PERCENT_IN_GENES:
        :type CNV_PERCENT_IN_GENES: double
        :param DELETIONS:
        :type DELETIONS: int
        :param DELETIONS_ALL:
        :type DELETIONS_ALL: int
        :param DELETIONS_IN_CODING_REGIONS:
        :type DELETIONS_IN_CODING_REGIONS: int
        :param DELETIONS_IN_EXONS:
        :type DELETIONS_IN_EXONS: int
        :param DELETIONS_IN_GENES:
        :type DELETIONS_IN_GENES: int
        :param DELETIONS_IN_MATURE_MIRNA:
        :type DELETIONS_IN_MATURE_MIRNA: int
        :param DELETIONS_IN_SPLICE_SITE_REGIONS:
        :type DELETIONS_IN_SPLICE_SITE_REGIONS: int
        :param DELETIONS_IN_UTR_REGIONS:
        :type DELETIONS_IN_UTR_REGIONS: int
        :param DELETIONS_PERCENT_FOUND_IN_DBSNP:
        :type DELETIONS_PERCENT_FOUND_IN_DBSNP: double
        :param DELETION_HET_HOM_RATIO:
        :type DELETION_HET_HOM_RATIO: double
        :param DIVERSITY:
        :type DIVERSITY: int
        :param FRAGMENT_LENGTH_MAX:
        :type FRAGMENT_LENGTH_MAX: int
        :param FRAGMENT_LENGTH_MEDIAN:
        :type FRAGMENT_LENGTH_MEDIAN: int
        :param FRAGMENT_LENGTH_MIN:
        :type FRAGMENT_LENGTH_MIN: int
        :param FRAGMENT_LENGTH_SD:
        :type FRAGMENT_LENGTH_SD: int
        :param FRAMESHIFT_DELETIONS:
        :type FRAMESHIFT_DELETIONS: int
        :param FRAMESHIFT_INSERTIONS:
        :type FRAMESHIFT_INSERTIONS: int
        :param INDELS:
        :type INDELS: int
        :param INDELS_ALL:
        :type INDELS_ALL: int
        :param INDELS_PERCENT_FOUND_IN_DBSNP:
        :type INDELS_PERCENT_FOUND_IN_DBSNP: double
        :param INDEL_HET_HOM_RATIO:
        :type INDEL_HET_HOM_RATIO: double
        :param INSERTIONS:
        :type INSERTIONS: int
        :param INSERTIONS_ALL:
        :type INSERTIONS_ALL: int
        :param INSERTIONS_IN_CODING_REGIONS:
        :type INSERTIONS_IN_CODING_REGIONS: int
        :param INSERTIONS_IN_EXONS:
        :type INSERTIONS_IN_EXONS: int
        :param INSERTIONS_IN_GENES:
        :type INSERTIONS_IN_GENES: int
        :param INSERTIONS_IN_MATURE_MIRNA:
        :type INSERTIONS_IN_MATURE_MIRNA: int
        :param INSERTIONS_IN_SPLICE_SITE_REGIONS:
        :type INSERTIONS_IN_SPLICE_SITE_REGIONS: int
        :param INSERTIONS_IN_UTR_REGIONS:
        :type INSERTIONS_IN_UTR_REGIONS: int
        :param INSERTIONS_PERCENT_FOUND_IN_DBSNP:
        :type INSERTIONS_PERCENT_FOUND_IN_DBSNP: double
        :param INSERTION_HET_HOM_RATIO:
        :type INSERTION_HET_HOM_RATIO: double
        :param MEAN_COVERAGE:
        :type MEAN_COVERAGE: double
        :param MISMATCH_RATE_READ_1:
        :type MISMATCH_RATE_READ_1: double
        :param MISMATCH_RATE_READ_2:
        :type MISMATCH_RATE_READ_2: double
        :param NON_SYNONYMOUS_DELETIONS:
        :type NON_SYNONYMOUS_DELETIONS: int
        :param NON_SYNONYMOUS_INSERTIONS:
        :type NON_SYNONYMOUS_INSERTIONS: int
        :param NON_SYNONYMOUS_SNVS:
        :type NON_SYNONYMOUS_SNVS: int
        :param PAIRED_END:
        :type PAIRED_END: boolean
        :param PERCENT_ALIGNED_BASES_READ_1:
        :type PERCENT_ALIGNED_BASES_READ_1: double
        :param PERCENT_ALIGNED_BASES_READ_2:
        :type PERCENT_ALIGNED_BASES_READ_2: double
        :param PERCENT_ALIGNED_READ_1:
        :type PERCENT_ALIGNED_READ_1: double
        :param PERCENT_ALIGNED_READ_2:
        :type PERCENT_ALIGNED_READ_2: double
        :param PERCENT_DUPLICATE_PAIRED_READS:
        :type PERCENT_DUPLICATE_PAIRED_READS: double
        :param PERCENT_Q30_BASES:
        :type PERCENT_Q30_BASES: double
        :param PERCENT_Q30_BASES_READ_1:
        :type PERCENT_Q30_BASES_READ_1: double
        :param PERCENT_Q30_BASES_READ_2:
        :type PERCENT_Q30_BASES_READ_2: double
        :param REFERENCE_GENOME:
        :type REFERENCE_GENOME: str
        :param RUNFOLDER:
        :type RUNFOLDER: str
        :param SAMPLE_ID:
        :type SAMPLE_ID: str
        :param SAMPLE_NAME:
        :type SAMPLE_NAME: str
        :param SNVS:
        :type SNVS: int
        :param SNVS_ALL:
        :type SNVS_ALL: int
        :param SNVS_IN_CODING_REGIONS:
        :type SNVS_IN_CODING_REGIONS: int
        :param SNVS_IN_EXONS:
        :type SNVS_IN_EXONS: int
        :param SNVS_IN_GENES:
        :type SNVS_IN_GENES: int
        :param SNVS_IN_MATURE_MIRNA:
        :type SNVS_IN_MATURE_MIRNA: int
        :param SNVS_IN_SPLICE_SITE_REGIONS:
        :type SNVS_IN_SPLICE_SITE_REGIONS: int
        :param SNVS_IN_UTR_REGIONS:
        :type SNVS_IN_UTR_REGIONS: int
        :param SNVS_PERCENT_FOUND_IN_DBSNP:
        :type SNVS_PERCENT_FOUND_IN_DBSNP: double
        :param SNV_HET_HOM_RATIO:
        :type SNV_HET_HOM_RATIO: double
        :param SNV_TS_TV_RATIO:
        :type SNV_TS_TV_RATIO: double
        :param STOP_GAINED_DELETIONS:
        :type STOP_GAINED_DELETIONS: int
        :param STOP_GAINED_INSERTIONS:
        :type STOP_GAINED_INSERTIONS: int
        :param STOP_GAINED_SNVS:
        :type STOP_GAINED_SNVS: int
        :param STOP_LOST_DELETIONS:
        :type STOP_LOST_DELETIONS: int
        :param STOP_LOST_INSERTIONS:
        :type STOP_LOST_INSERTIONS: int
        :param STOP_LOST_SNVS:
        :type STOP_LOST_SNVS: int
        :param SV_DELETIONS:
        :type SV_DELETIONS: int
        :param SV_DELETIONS_IN_GENES:
        :type SV_DELETIONS_IN_GENES: int
        :param SV_INSERTIONS:
        :type SV_INSERTIONS: int
        :param SV_INSERTIONS_IN_GENES:
        :type SV_INSERTIONS_IN_GENES: int
        :param SV_INVERSIONS:
        :type SV_INVERSIONS: int
        :param SV_INVERSIONS_IN_GENES:
        :type SV_INVERSIONS_IN_GENES: int
        :param SV_PERCENT_DELETIONS_IN_GENES:
        :type SV_PERCENT_DELETIONS_IN_GENES: double
        :param SV_PERCENT_INSERTIONS_IN_GENES:
        :type SV_PERCENT_INSERTIONS_IN_GENES: double
        :param SV_PERCENT_INVERSIONS_IN_GENES:
        :type SV_PERCENT_INVERSIONS_IN_GENES: double
        :param SV_PERCENT_TANDEM_DUPLICATIONS_IN_GENES:
        :type SV_PERCENT_TANDEM_DUPLICATIONS_IN_GENES: double
        :param SV_TANDEM_DUPLICATIONS:
        :type SV_TANDEM_DUPLICATIONS: int
        :param SV_TANDEM_DUPLICATIONS_IN_GENES:
        :type SV_TANDEM_DUPLICATIONS_IN_GENES: int
        :param SYNONYMOUS_SNVS:
        :type SYNONYMOUS_SNVS: int
        :param TOTAL_ALIGNED_BASES_READ_1:
        :type TOTAL_ALIGNED_BASES_READ_1: int
        :param TOTAL_ALIGNED_BASES_READ_2:
        :type TOTAL_ALIGNED_BASES_READ_2: int
        :param TOTAL_ALIGNED_READ_1:
        :type TOTAL_ALIGNED_READ_1: int
        :param TOTAL_ALIGNED_READ_2:
        :type TOTAL_ALIGNED_READ_2: int
        :param TOTAL_PF_BASES:
        :type TOTAL_PF_BASES: int
        :param TOTAL_PF_BASES_READ_1:
        :type TOTAL_PF_BASES_READ_1: int
        :param TOTAL_PF_BASES_READ_2:
        :type TOTAL_PF_BASES_READ_2: int
        :param TOTAL_PF_READS:
        :type TOTAL_PF_READS: int
        :param illumina_version:
        :type illumina_version: IlluminaVersion
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.3"
